Subject: bug#19954: closed (python.el: more consistent sexp navigation)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 13 Apr 2015 01:45:03 +0000

Your bug report

#19954: python.el: more consistent sexp navigation

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
19954: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=19954
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: python.el: more consistent sexp navigation
From: [email-masked] (Fabián Ezequiel Gallina)
To: [email-masked]
Date: Sun, 12 Apr 2015 22:44:52 -0300
List-Id: <debbugs-submit.debbugs.gnu.org>

Fixed at 659609d in the master branch.

Thanks,
Fabián.

Subject: python.el: more consistent sexp navigation
From: Carlos Pita <[email-masked]>
To: [email-masked]
Date: Thu, 26 Feb 2015 14:26:04 -0300
List-Id: <debbugs-submit.debbugs.gnu.org>

X-Debbugs-CC: [email-masked]

If this is a feature I recognize I don't understand the rationally
behind it:

        [...]
            (and (not forward-p)
                 (eq (syntax-class (syntax-after (1- (point))))
                     (car (string-to-syntax ")")))))
        ;; Inside a paren or looking at it, lisp knows what to do.

Say * is the point. The inconsistency I find is that C-M-left will do
very different things while at the end of different lines:

A)
from sklearn.cross_validation import KFold*
-->
*from sklearn.cross_validation import KFold

B)
n = len(train.y)*
-->
n = len*(train.y)

I think the intention is to nav at the "statement/block level" when the point
is at the end of the line. The difference of behaviour between A and B
can't be reconciled at any level: sexp, list, statement, block. My
expectation would be:

B')
n = len(train.y)*
-->
*n = len(train.y)

B'')
n = len(train.y*)
-->
n = len(train.*y)

Notice that this is even more conspicuous at the end of a block:

C)
for x in range(0, 10):
    x = 2
    print("hello")*
-->
for x in range(0, 10):
    x = 2
    print*("hello")

D)
for x in range(0, 10):
    print("hello")
    x = 2*
-->
*for x in range(0, 10):
    print("hello")
    x = 2

I vote for removing the (syntax-after (1- (point)) special case as IMO
it only adds confussion to the already complex nav rules.

Cheers
--
Carlos